3540: [Usaco2014 Open]Fair Photography

3540: [Usaco2014 Open]Fair Photography

Time Limit: 1 Sec   Memory Limit: 128 MB
Submit: 200   Solved: 93
[ Submit][ Status][ Discuss]

Description

FJ's N cows (2 <= N <= 100,000) are standing at various positions along a long one-dimensional fence. The ith cow is standing at position x_i (an integer in the range 0...1,000,000,000) and is either a plain white cow or a spotted cow. No two cows occupy the same position, and there is at least one white cow. FJ wants to take a photo of a contiguous interval of cows for the county fair, but in fairness to his different cows, he wants to ensure there are equal numbers of white and spotted cows in the photo. FJ wants to determine the maximum size of such a fair photo, where the size of a photo is the difference between the maximum and minimum positions of the cows in the photo. To give himself an even better chance of taking a larger photo, FJ has with him a bucket of paint that he can use to paint spots on an arbitrary subset of his white cows of his choosing, effectively turning them into spotted cows. Please determine the largest size of a fair photo FJ can take, given that FJ has the option of painting some of his white cows (of course, he does not need to paint any of the white cows if he decides this is better).

可以先任意把0染成1.

区间长度定义为,[L,R]中最右和最左的数的差的绝对值.

求一个最长区间,满足区间中所有数0和1的个数相同.

Input

 * Line 1: The integer N.

* Lines 2..1+N: Line i+1 contains x_i and either W (for a white cow) or S (for a spotted cow). 

Output

* Line 1: The maximum size of a fair photo FJ can take, after possibly painting some of his white cows to make them spotted.

Sample Input

5
8 W
11 S
3 W
10 W
5 S

INPUT DETAILS: There are 5 cows. One of them is a white cow at position 8, and so on.

Sample Output

7
OUTPUT DETAILS: FJ takes a photo of the cows from positions 3 to positions 10.
There are 4 cows in this range -- 3 white and 1 spotted -- so he needs to paint one
of the white cows to make it spotted.

HINT

Source

题解:
将0看做是-1,不难理解前缀和相同的中间一段是满足题意的序列。

(记录每一个前缀和,第一次出现的地方last[x]。)

但题目中说可以将0改为1,思考ing

我们来考虑什么时候x+2会在x前出现,无疑是当有两个-1和一段长度不定和为0组成的,也就是说,在这种时候,我们可以将两个-1中的一个更改,得到更大的合法序列。

也就是可以用last[x+2]来更新last[x]的值。

注意:

1.前缀和可以出现负数,所以不妨设一开始为n,保证数组下标为正

2.x,y前缀和相同时,要注意序列是x+1~y

在bzoj上跑了第一O(∩_∩)O~~

代码:

#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<algorithm>
#include<cmath>
#include<queue>
#define maxn 100005
using namespace std;
int read()
{
	int x=0,f=1;char ch=getchar();
	while(ch<'0'||ch>'9'){if(ch=='-')f=-1;ch=getchar();}
	while(ch>='0'&&ch<='9'){x=x*10+ch-'0';ch=getchar();}
  return x*f;
}
int n,last[2*maxn],ans;
struct Node{
	int pos,v;
}a[maxn];
bool cmp(Node x,Node y){return x.pos<y.pos;}
int main()
{
//	 freopen("input.in","r",stdin);
//	 freopen("output.out","w",stdout);
    n=read();
    for(int i=1;i<=n;i++)
    {
      a[i].pos=read();
    	char ch=getchar();
    	while(ch!='W'&&ch!='S')ch=getchar();
    	if(ch=='W')a[i].v=-1;else a[i].v=1;
    }
    sort(a+1,a+1+n,cmp);
    memset(last,127,sizeof(last));
    int sum=n;
    last[sum]=a[1].pos;
    for(int i=1;i<n;i++)
    {
    	sum+=a[i].v;
    	last[sum]=min(last[sum],a[i+1].pos);
    }
    for(int i=2*n;i>=0;i--)
      last[i]=min(last[i],last[i+2]);
    ans=0;sum=n;
		for(int i=1;i<=n;i++)
    {
    	sum+=a[i].v;
    	ans=max(ans,a[i].pos-last[sum]);
    }
    printf("%d\n",ans);
    return 0;
}

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值